/*
file   : uartx.h
author : shentq
version: V1.0
date   : 2015/7/5

Copyright 2015 shentq. All Rights Reserved.

Copyright Notice
No part of this software may be used for any commercial activities by any form or means, without the prior written consent of shentq.

Disclaimer
This specification is preliminary and is subject to change at any time without notice. shentq assumes no responsibility for any errors contained herein.
*/

#ifndef __UARTX_H
#define __UARTX_H

#include "common.h"
#include <stdio.h>
#include <stdarg.h>  


/*
	1.ִ֧1,2,3,4,5
	2.֧һж¼ rx_it
	3.ģʽDMAԶģʽʡcpuռáͻΪUART_MAX_SEND_BUF
	4.֧ǿprintf
	5.ʱ֧ŵremap
    ע⣺
        ͻܵµƬ쳣
        45ûʹDMA
        ڷͣno_interruptִΡ
*/

/**
 *@name     void    begin(uint32_t baud_rate,uint8_t data_bit,uint8_t parity,float stop_bit);
 *@brief    ڳʼиò
 *@param    baud_rate:  ʣ960011520038400ȵ
 *          data_bit:   λֻ89
 *          parity:     λ0Уλ1У飬2żУ
 *          stop_bit:   ֹͣλ0.5,1,1.5,2ĸѡ
 *@retval   None
*/
//û//////////////
#define USE_DMA 1//dmaֻд123֧,45֧
#define UART_MAX_SEND_BUF 128

class USART
{
    public:
        USART(USART_TypeDef *USARTx,GPIO *tx_pin,GPIO *rx_pin);

        void    begin(uint32_t baud_rate);
        void    begin(uint32_t baud_rate,uint8_t data_bit,uint8_t parity,float stop_bit);
        void    attach_rx_interrupt(void (*callback_fun)(void));
        void    attach_tx_interrupt(void (*callback_fun)(void));

        int 	put_char(uint16_t ch);
        void 	put_string(const char *str);
        void    printf_length(const char *str,uint16_t length);
        void    printf(const char *fmt,...);//Ҫע⻺
        void    wait_busy();
    
        uint16_t    receive();

    private:
        USART_TypeDef       *_USARTx;
        DMA_Channel_TypeDef *_DMA1_Channelx;
        char                send_buf[UART_MAX_SEND_BUF];
        uint16_t            dma_send_string(const char *str,uint16_t length);
        void                put_string(const char *str,uint16_t length);
        void                set_busy();
        void                interrupt(FunctionalState enable);
};






#endif
