/*
file   : mmc_sd.cpp
*/

#include "mmc_sd.h"


int SD::begin(uint8_t dev_num)
{
	int ret = 0;
	SPIDevSDCard.dev_num = dev_num;
	SPIDevSDCard.mode = SPI_MODE0;
	SPIDevSDCard.prescaler = SPI_CLOCK_DIV2;
	SPIDevSDCard.bit_order = SPI_BITODER_MSB;
		
	cs->mode(OUTPUT_PP);
	cs->set();
	SD_Type = 0;
	
	ret = init();
	return ret;
}
/*******************************************************************************
* Function Name  : SD_WaitReady
* Description    : ȴSDReady
* Input          : None
* Output         : None
* Return         : u8 
*                   0 ɹ
*                   otherʧ
*******************************************************************************/

uint8_t SD::_wait(void)
{
  u8 r1 = 0;
  u16 retry=0;
  do
  {
    r1 = spi->read();
    retry++;
    if(retry==0xfffe)
      return 1; 
  }while(r1!=0xFF); 
	return 0;
}
/*******************************************************************************
* Function Name  : SD_SendCommand
* Description    : SDһ
* Input          : u8 cmd    
*                  u32 arg  
*                  u8 crc   crcУֵ
* Output         : None
* Return         : u8 r1 SDصӦ
*******************************************************************************/
uint8_t SD::_send_command(u8 cmd, u32 arg,u8 crc)
{
  unsigned char r1 = 0;
  unsigned int Retry = 0;

 
	cs->set();
	spi->write(0xff);//߼ԣûЩSD֧ܲ
	cs->reset();//ƬѡõͣѡSD
	
  /*  */
  spi->write(cmd | 0x40);                      
  spi->write((u8)(arg >> 24));//[31..24]
  spi->write((u8)(arg >> 16));//[23..16]
  spi->write((u8)(arg >> 8));//[15..8]
  spi->write((u8)arg);    //[7..0]
  spi->write(crc);
    
  //ȴӦʱ˳
  while((r1 = spi->read())==0xFF)
  {
    Retry++;
    if(Retry > 800)break; //ʵãԴ
  }   
  //رƬѡ
	cs->set();
  //϶8ʱӣSDʣµĹ
  spi->write(0xFF);

  //״ֵ̬
  return r1;
}
/*******************************************************************************
* Function Name  : SD_SendCommand_NoDeassert
* Description    : SDһ(ǲʧƬѡкݴ
* Input          : u8 cmd    
*                  u32 arg  
*                  u8 crc   crcУֵ
* Output         : None
* Return         : u8 r1 SDصӦ
*******************************************************************************/
uint8_t SD::_send_command_no_deassert(u8 cmd, u32 arg,u8 crc)
{
  unsigned char r1 = 0;
  unsigned int Retry = 0;
	

	cs->set();
	spi->write(0xff);//߼ԣûЩSD֧ܲ
	cs->reset();//ƬѡõͣѡSD
  
  /*  */
  spi->write(cmd | 0x40);                      
  spi->write((u8)(arg >> 24));//[31..24]
  spi->write((u8)(arg >> 16));//[23..16]
  spi->write((u8)(arg >> 8));//[15..8]
  spi->write((u8)arg);    //[7..0]
  spi->write(crc);
  
  //ȴӦʱ˳
  while((r1 = spi->read())==0xFF)
  {
    Retry++;
    if(Retry > 600)break; //ʵãԴ  
  }
  //Ӧֵ
  return r1;
}
/*******************************************************************************
* Function Name  : SD_Init
* Description    : ʼSD
* Input          : None
* Output         : None
* Return         : u8 
*                  0NO_ERR
*                  1TIME_OUT
*                  99NO_CARD
*******************************************************************************/
uint8_t SD::init()
{
  u16 i = 0;      // ѭ
  u8 r1 = 0;      // SDķֵ
  u16 retry = 0;  // гʱ
  u8 buff[6];
	
	SPIDevSDCard.prescaler = SPI_CLOCK_DIV256;
	spi->begin(&SPIDevSDCard);
	cs->reset();
	  // ʱȴSDϵ
  for(i=0;i<0xf00;i++);

  //Ȳ74壬SDԼʼ
  for(i=0;i<10;i++)
  {
    spi->write(0xFF);//80clks
  }
	  //-----------------SDλidleʼ-----------------
  //ѭCMD0ֱSD0x01,IDLE״̬
  //ʱֱ˳
  retry = 0;
  do
  {
    //CMD0SDIDLE״̬
    r1 = _send_command(CMD0, 0,0x95);
    retry++;
  }while((r1 != 0x01) && (retry<200));
  //ѭ󣬼ԭ򣺳ʼɹor Գʱ
  if(retry==200) return 1;   //ʱ1	
	
	
  //-----------------SDλidle-----------------	 
  //ȡƬSD汾Ϣ
  r1 = _send_command_no_deassert(CMD8, 0x1aa,0x87);	     
    //Ƭ汾Ϣv1.0汾ģr1=0x05³ʼ
  if(r1 == 0x05)
  {
     //ÿΪSDV1.0⵽ΪMMC޸ΪMMC
     SD_Type = SD_TYPE_V1;	   
     //V1.0CMD8ָûк
     //Ƭѡøߣ
     cs->set();
     //෢8CLKSD
     spi->write(0xFF);	  
     //-----------------SDMMCʼʼ-----------------	 
     //ʼָCMD55+ACMD41
     // Ӧ˵SDҳʼ
     // ûлӦ˵MMCӦʼ
     retry = 0;
     do
     {
       //ȷCMD55Ӧ0x01
       r1 = _send_command(CMD55, 0, 0);
       if(r1 != 0x01)
         return r1;	  
       //õȷӦ󣬷ACMD41Ӧõֵ0x00400
       r1 = _send_command(ACMD41, 0, 0);
       retry++;
     }while((r1!=0x00) && (retry<400));
     // жǳʱǵõȷӦ
     // лӦSDûлӦMMC
        
     //----------MMCʼʼ------------
     if(retry==400)
     {
        retry = 0;
        //MMCʼûвԣ
        do
        {
           r1 = _send_command(CMD1, 0, 0);
           retry++;
        }while((r1!=0x00)&& (retry<400));
        if(retry==400)return 1;   //MMCʼʱ		    
        //д뿨
        SD_Type = SD_TYPE_MMC;
     }
     //----------MMCʼ------------	    
     //SPIΪģʽ
		 SPIDevSDCard.prescaler = SPI_CLOCK_DIV2;
		 spi->config(&SPIDevSDCard);

     spi->write(0xFF);
        
     //ֹCRCУ	   
     r1 = _send_command(CMD59, 0, 0x95);
     if(r1 != 0x00)return r1;  //󣬷r1   	   
     //Sector Size
     r1 = _send_command(CMD16, 512, 0x95);
     if(r1 != 0x00)return r1;//󣬷r1		 
     //-----------------SDMMCʼ-----------------

  }//SDΪV1.0汾ĳʼ	 
  //V2.0ĳʼ
  //ҪȡOCRݣжSD2.0SD2.0HC
  else if(r1 == 0x01)
  {
    //V2.0ĿCMD8ᴫ4ֽڵݣҪٽ
    buff[0] = spi->read();  //should be 0x00
    buff[1] = spi->read();  //should be 0x00
    buff[2] = spi->read();  //should be 0x01
    buff[3] = spi->read();  //should be 0xAA	   
		cs->set();
		spi->write(0xFF);//the next 8 clocks			 
    //жϸÿǷ֧2.7V-3.6VĵѹΧ
    //if(buff[2]==0x01 && buff[3]==0xAA) //粻жϣֵ֧Ŀ
   // {	  
       retry = 0;
       //ʼָCMD55+ACMD41
       do
       {
    	  r1 = _send_command(CMD55, 0, 0);
    	  if(r1!=0x01)return r1;	   
    	  r1 = _send_command(ACMD41, 0x40000000, 1);
          if(retry>200)return r1;  //ʱ򷵻r1״̬  
       }while(r1!=0);		  
       //ʼָɣȡOCRϢ		   
       //-----------SD2.0汾ʼ-----------
       r1 = _send_command_no_deassert(CMD58, 0, 0);
       if(r1!=0x00)return r1;  //ûзȷӦֱ˳Ӧ		 
       //OCRָ󣬽4ֽڵOCRϢ
       buff[0] = spi->read();
       buff[1] = spi->read(); 
       buff[2] = spi->read();
       buff[3] = spi->read();

       //OCRɣƬѡø
			 cs->set();
       spi->write(0xFF);

       //յOCRеbit30λCCSȷΪSD2.0SDHC
       //CCS=1SDHC   CCS=0SD2.0
       if(buff[0]&0x40)SD_Type = SD_TYPE_V2HC;    //CCS	 
       else SD_Type = SD_TYPE_V2;	    
       //-----------SD2.0汾----------- 
       //SPIΪģʽ
			 SPIDevSDCard.prescaler = SPI_CLOCK_DIV2;
			spi->config(&SPIDevSDCard);
			
   // }	    
  }
    return r1;
}
/*******************************************************************************
* Function Name  : SD_ReceiveData
* Description    : SDжָȵݣڸλ
* Input          : u8 *data(Ŷݵڴ>len)
*                  u16 len(ݳȣ
*                  u8 release(ɺǷͷCSø 0ͷ 1ͷţ
* Output         : None
* Return         : u8 
*                  0NO_ERR
*                  otherϢ
*******************************************************************************/
int SD::_receive_data(u8 *data, u16 len, u8 release)
{
  u16 retry;
  u8 r1;
  // һδ
  cs->reset();
  //ȴSDʼ0xFE
  retry = 0;										   
  do
  {
    r1 = spi->read();
    retry++;
    if(retry>4000)  //4000εȴûӦ˳(ʵԣ˴öԼ
    {
      cs->set();
        return 1;
    }
    }while(r1 != 0xFE);
		   
    //ʼ
    while(len--)
    {
      *data = spi->read();
      data++;
    }
    //2αCRCdummy CRC
    spi->write(0xFF);
    spi->write(0xFF);
    //ͷߣCSø
    if(release == RELEASE)
    {
      //
      cs->set();
      spi->write(0xFF);
    }											  					    
    return 0;
}
/*******************************************************************************
* Function Name  : SD_GetCID
* Description    : ȡSDCIDϢϢ
* Input          : u8 *cid_data(CIDڴ棬16Byte
* Output         : None
* Return         : u8 
*                  0NO_ERR
*                  1TIME_OUT
*                  otherϢ
*******************************************************************************/
int SD::get_CID(u8 *cid_data)
{
  u8 r1;
	
	spi->take_spi_right(&SPIDevSDCard);

  //CMD10CID
  r1 = _send_command(CMD10, 0, 0xFF);
  if(r1 != 0x00)return r1;  //ûȷӦ˳    
  //16ֽڵ
  _receive_data(cid_data, 16, RELEASE);	
	spi->release_spi_right();	
  return 0;
}
/*******************************************************************************
* Function Name  : SD_GetCSD
* Description    : ȡSDCSDϢٶϢ
* Input          : u8 *cid_data(CIDڴ棬16Byte
* Output         : None
* Return         : u8 
*                  0NO_ERR
*                  1TIME_OUT
*                  otherϢ
*******************************************************************************/
int SD::get_CSD(u8 *csd_data)
{
  u8 r1;

	spi->take_spi_right(&SPIDevSDCard);
  //CMD9CSD
  r1 = _send_command(CMD9, 0, 0xFF);
  if(r1 != 0x00)return r1;  //ûȷӦ˳  
  //16ֽڵ
  _receive_data(csd_data, 16, RELEASE);
	spi->release_spi_right();	

  return 0;
}
/*******************************************************************************
* Function Name  : SD_GetCapacity
* Description    : ȡSDֽڣ
* Input          : None
* Output         : None
* Return         : u32 capacity 
*                   0 ȡ 
*******************************************************************************/
u32 SD::get_capacity(void)
{
  u8 csd[16];
  u32 Capacity;
  u8 r1;
  u16 i;
  u16 temp;
	spi->take_spi_right(&SPIDevSDCard);

  //ȡCSDϢڼ0
  if(get_CSD(csd)!=0) return 0;	    
  //ΪSDHC淽ʽ
  if((csd[0]&0xC0)==0x40)
  {									  
    Capacity=((u32)csd[8])<<8;
    Capacity+=(u32)csd[9]+1;	 
    Capacity = (Capacity)*1024;//õ
    Capacity*=512;//õֽ			   
  }
  else
  {		    
    i = csd[6]&0x03;
    i<<=8;
    i += csd[7];
    i<<=2;
    i += ((csd[8]&0xc0)>>6);
    
    //C_SIZE_MULT
    r1 = csd[9]&0x03;
    r1<<=1;
    r1 += ((csd[10]&0x80)>>7);	 
    r1+=2;//BLOCKNR
    temp = 1;
    while(r1)
    {
      temp*=2;
      r1--;
    }
    Capacity = ((u32)(i+1))*((u32)temp);	 
    // READ_BL_LEN
    i = csd[5]&0x0f;
    //BLOCK_LEN
    temp = 1;
    while(i)
    {
      temp*=2;
      i--;
    }
    //The final result
    Capacity *= (u32)temp;//ֽΪλ 	  
  }
		spi->release_spi_right();	

  return (u32)Capacity;
}
/*******************************************************************************
* Function Name  : SD_ReadSingleBlock
* Description    : SDһblock
* Input          : u32 sector ȡַsectorֵַ 
*                  u8 *buffer ݴ洢ַС512byte 
* Output         : None
* Return         : u8 r1 
*                   0 ɹ
*                   otherʧ
*******************************************************************************/
u8 SD::read_single_block(u32 sector, u8 *buffer)
{
  u8 r1;

  //Ϊģʽ
  SPIDevSDCard.prescaler = SPI_CLOCK_DIV2;
	spi->take_spi_right(&SPIDevSDCard);
	
  
  //SDHCsectorַתbyteַ
  sector = sector<<9;

  r1 = _send_command(CMD17, sector, 1);//
												    
  if(r1 != 0x00)return r1; 		   							  
  r1 = _receive_data(buffer, 512, RELEASE);
	
	spi->release_spi_right();	
	
  if(r1 != 0)
    return r1;   //ݳ
  else 
    return 0; 
}
/*******************************************************************************
* Function Name  : SD_WriteSingleBlock
* Description    : дSDһblock
* Input          : u32 sector ַsectorֵַ 
*                  u8 *buffer ݴ洢ַС512byte 
* Output         : None
* Return         : u8 r1 
*                   0 ɹ
*                   otherʧ
*******************************************************************************/
u8 SD::write_single_block(u32 sector,  u8 *data)
{
  u8 r1;
  u16 i;
  u16 retry;
  //Ϊģʽ
	SPIDevSDCard.prescaler = SPI_CLOCK_DIV2;
	spi->take_spi_right(&SPIDevSDCard);

  //SDHCsectorַתbyteַ
  if(SD_Type!=SD_TYPE_V2HC)
  {
     sector = sector<<9;//512*sectorıַ߽
  }

  r1 = _send_command(CMD24, sector, 0x01);
  if(r1 != 0x00)
  {
    return r1;  //Ӧȷֱӷ
  }
    
  //ʼ׼ݴ
  cs->reset();
  //ȷ3ݣȴSD׼
  spi->write(0xff);
  spi->write(0xff);
  spi->write(0xff);
  //ʼ0xFE
  spi->write(0xFE);

  //һsector
  for(i=0;i<512;i++)
  {
     spi->write(*data++);
  }
  //2Bytedummy CRC
  spi->write(0xff);
  spi->write(0xff);
    
  //ȴSDӦ
  r1 = spi->read();
  if((r1&0x1F)!=0x05)
  {
     cs->set();
     return r1;
  }
    
  //ȴ
  retry = 0;
  while(!spi->write(0xff))//Աʱ߱
  {
     retry++;
     if(retry>65534)        //ʱдûɣ˳
     {
        cs->set();
        return 1;           //д볬ʱ1
     }
  }

  //дɣƬѡ1
  cs->set();
  spi->write(0xff);
	
	spi->release_spi_right();	
	

  return 0;
}
/*******************************************************************************
* Function Name  : SD_ReadMultiBlock
* Description    : SDĶblock
* Input          : u32 sector ȡַsectorֵַ 
*                  u8 *buffer ݴ洢ַС512byte
*                  u8 count countblock
* Output         : None
* Return         : u8 r1 
*                   0 ɹ
*                   otherʧ
*******************************************************************************/
u8 SD::read_multi_block(u32 sector, u8 *buffer, u8 count)
{
  u8 r1;	 			 
	
	SPIDevSDCard.prescaler = SPI_CLOCK_DIV2;
	spi->take_spi_right(&SPIDevSDCard);
	
  sector = sector<<9;//SDHCsectorַתbyteַ
 //SD_WaitReady();
 //
  r1 = _send_command(CMD18, sector, 1);//
  if(r1 != 0x00)return r1;	 
  do//ʼ
  {
    if(_receive_data(buffer, 512, NO_RELEASE) != 0x00)
    {
       break;
    }
    buffer += 512;
  } while(--count);		 
  //ȫϣֹͣ
  _send_command(CMD12, 0, 1);
  //ͷ
  cs->set();
  spi->write(0xFF);    
	
	spi->release_spi_right();	
	
  if(count != 0)
    return count;   //ûд꣬ʣ	 
  else 
    return 0;	 
}
/*******************************************************************************
* Function Name  : SD_WriteMultiBlock
* Description    : дSDNblock
* Input          : u32 sector ַsectorֵַ 
*                  u8 *buffer ݴ洢ַС512byte
*                  u8 count дblockĿ
* Output         : None
* Return         : u8 r1 
*                   0 ɹ
*                   otherʧ
*******************************************************************************/
u8 SD::write_multi_block(u32 sector,  const u8 *data, u8 count)
{
  u8 r1;
  u16 i;	 		 
	
	SPIDevSDCard.prescaler = SPI_CLOCK_DIV2;
	spi->take_spi_right(&SPIDevSDCard);

	
  if(SD_Type != SD_TYPE_V2HC)
    sector = sector<<9;//SDHCsectorַתbyteַ  
  if(SD_Type != SD_TYPE_MMC) 
    r1 = _send_command(ACMD23, count, 0x01);//Ŀ꿨MMCACMD23ָʹԤ   
  r1 = _send_command(CMD25, sector, 0x01);//дָ
  if(r1 != 0x00)return r1;  //Ӧȷֱӷ	 
  cs->reset();//ʼ׼ݴ   
  spi->write(0xff);//ȷ3ݣȴSD׼
  spi->write(0xff);   
  //--------Nsectorдѭ
  do
  {
    //ʼ0xFC Ƕд
     spi->write(0xFC);	  
     //һsector
     for(i=0;i<512;i++)
     {
        spi->write(*data++);
     }
     //2Bytedummy CRC
     spi->write(0xff);
     spi->write(0xff);
        
     //ȴSDӦ
     r1 = spi->read();
     if((r1&0x1F)!=0x05)
     {
        cs->set();    //ӦΪֱ˳
        return r1;
     }

     //ȴSDд
     if(_wait()==1)
     {
        cs->set();    //ȴSDдɳʱֱ˳
        return 1;
     }	   
    }while(--count);//sectorݴ
    
    //0xFD
    r1 = spi->write(0xFD);
    if(r1==0x00)
    {
       count =  0xfe;
    }		   
    if(_wait()) //ȴ׼
    {
      cs->set();
      return 1;  
    }
    //дɣƬѡ1
    cs->set();
    spi->write(0xff);  
		
	spi->release_spi_right();	
	
    return count;   //countֵдcount=0count=1
}
/*******************************************************************************
* Function Name  : SD_Read_Bytes
* Description    : ָ,offsetʼbytesֽ
* Input          : u32 address ַsectorֵַ 
*                  u8 *buf     ݴ洢ַС<=512byte
*                  u16 offset  ƫ
                   u16 bytes   Ҫֽ
* Output         : None
* Return         : u8 r1 
*                   0 ɹ
*                   otherʧ
*******************************************************************************/
u8 SD::read_bytes(unsigned long address,unsigned char *buf,unsigned int offset,unsigned int bytes)
{
  u8 r1;u16 i=0;  
	
	spi->take_spi_right(&SPIDevSDCard);

  r1=_send_command(CMD17,address<<9,1);//Ͷ      
  if(r1!=0x00)return r1;  //Ӧȷֱӷ
  cs->reset();//ѡSD
  while (spi->read()!= 0xFE)//ֱȡݵĿʼͷ0XFEż
  {
    i++;
    if(i>3000)
    {
      cs->set();//رSD
      return 1;//ȡʧ
    }
  }; 		 
  for(i=0;i<offset;i++)
    spi->read();//offsetλ 
  for(;i<offset+bytes;i++)
    *buf++=spi->read();//ȡ	
  for(;i<512;i++) 
    spi->write(0xff); 	 //ʣֽ
  spi->write(0xff);//αCRC
  spi->write(0xff);  
  cs->set();//رSD
	
	spi->release_spi_right();	
	

  return 0;
}




