
#include "ebox.h"
#include "Max7456.h"
#include "ringbuf.h"
#include "can.h"
#include "usb_wrapper.h"
#include "setting.h"
#include "OSD_Panels.h"


extern OSD osd;
extern RINGBUF uart_rx_buf;



extern u8 Receive_Buffer[64];
extern u8 Transi_Buffer[64];
extern u8 USB_ReceiveFlg;


FLASHCLASS iflash;


uint8_t deflaut_item_value[64] = {ON,1,0,ON,7,0,ON,11,0,ON,11,1,ON,19,0,ON,25,0,ON,14,2,ON,8,5,ON,1,6,ON,1,7,ON,24,7,ON,1,12,ON,1,14,ON,1,1,ON,20,14};


item_data_t battary_voltage;//0
item_data_t battary_percent;//1
item_data_t pitch;//2
item_data_t roll;//3


item_data_t airspeed;//4
item_data_t GPS_number;//5
item_data_t home_direction;//6
item_data_t horizonr;//7

item_data_t home_distance;//8
item_data_t home_altitude;//9
item_data_t clamb_speed;//10
item_data_t flight_mode;//11

item_data_t gps_value;//12
item_data_t on_time;//13
item_data_t heading;//14


void upload_font()
{
    uint16_t byte_count = 0;
    uint8_t bit_count;
    uint8_t ascii_binary[0x08];

    // move these local to prevent ram usage
    uint8_t character_bitmap[0x40];
    int font_count = 0;

    osd.clear();
    osd.setPanel(6,9);
    osd.openPanel();
    osd.printf("Update CharSet"); 
    osd.closePanel();


    uart1.printf("Ready for Font\n");//debug


    while(font_count < 256) { 
        //int8_t incomingByte = Serial.read();//to do 
					int8_t incomingByte = uart_rx_buf.read();
			
        switch(incomingByte) // parse and decode mcm file
        {
        case 0x0d: // carridge return, end of line
            //Serial.println("cr");
            if (bit_count == 8 && (ascii_binary[0] == 0x30 || ascii_binary[0] == 0x31))
            {
                // turn 8 ascii binary bytes to single byte '01010101' = 0x55
                // fill in 64 bytes of character data
                // made this local to prevent needing a global
                uint8_t ascii_byte;

                ascii_byte = 0;

                if (ascii_binary[0] == 0x31) // ascii '1'
                    ascii_byte = ascii_byte + 128;

                if (ascii_binary[1] == 0x31)
                    ascii_byte = ascii_byte + 64;

                if (ascii_binary[2] == 0x31)
                    ascii_byte = ascii_byte + 32;

                if (ascii_binary[3] == 0x31)
                    ascii_byte = ascii_byte + 16;

                if (ascii_binary[4] == 0x31)
                    ascii_byte = ascii_byte + 8;

                if (ascii_binary[5] == 0x31)
                    ascii_byte = ascii_byte + 4;

                if (ascii_binary[6] == 0x31)
                    ascii_byte = ascii_byte + 2;

                if (ascii_binary[7] == 0x31)
                    ascii_byte = ascii_byte + 1;

                character_bitmap[byte_count] = ascii_byte;
                byte_count++;
                bit_count = 0;
            }
            else
                bit_count = 0;
            break;
        case 0x0a: // line feed, ignore
            //Serial.println("ln");   
            break;
        case 0x30: // ascii '0'
        case 0x31: // ascii '1' 
            ascii_binary[bit_count] = incomingByte;
            bit_count++;
            break;
        default:
            break;
        }

        // we have one completed character
        // write the character to NVM 
        if(byte_count == 64)
        {
            osd.write_NVM(font_count, character_bitmap);    
            byte_count = 0;
            font_count++;
            uart1.printf("Char Done\n"); //debug 

        }
    }

    //  character_bitmap[]
}


void check_update_fontmode(void)
{
  static uint8_t crlf_count = 0;  
	while(uart_rx_buf.available() > 0) { 
				//no_interrupts();
        uint8_t c = uart_rx_buf.read();
			 // interrupts();
 
        /* allow CLI to be started by hitting enter 3 times, if no
        heartbeat packets have been received */
        if (1) {
            if (c == '\n' || c == '\r') {
                crlf_count++;
            } else {
                crlf_count = 0;
            }
            if (crlf_count == 3) {
                upload_font();
            }
        }
	}
}

void usb_updata_font(void)
{
     while(1) //
     {
         if (USB_ReceiveFlg == 1) //յλݺ󣬽1SһݸPC
         {
			USB_ReceiveFlg = 0;
			//to do burn to max7456
			if(Receive_Buffer[63] == CMD_REQ_BURN_MCM_COUNT)
			{
				uint8_t cnt= Receive_Buffer[62];
				//
				osd.write_NVM(cnt, Receive_Buffer);  
				Transi_Buffer[63]  = CMD_ACK_BURN_MCM_COUNT;
				Transi_Buffer[62] = cnt;
				USB_SendString(Transi_Buffer); 
			}
			if(Receive_Buffer[63] == CMD_SET_CONFIG)
			{
				osd.clear();
				load_item_value(Receive_Buffer);
				FLASH_Unlock();  //??FLASH???????
				FLASH_ClearFlag(FLASH_FLAG_BSY|FLASH_FLAG_EOP|FLASH_FLAG_PGERR|FLASH_FLAG_WRPRTERR);//?????
				FLASH_ErasePage(0x800fc00);     //???????
				iflash.write(0x800fc00,Receive_Buffer,64);				
				OSD_test_display();
			}
			if(Receive_Buffer[63] == CMD_REQ_CONFIG)
			{
				iflash.read(0x800fc00,Transi_Buffer,64);
				Transi_Buffer[63]  = CMD_REQ_CONFIG;
				USB_SendString(Transi_Buffer); 
			}
			 
      }
     }

}


void load_item_value(uint8_t * buffer)
{
	battary_voltage.on_off = buffer[3*0+0];
	battary_voltage.x = buffer[3*0+1];
	battary_voltage.y = buffer[3*0+2];

	battary_percent.on_off = buffer[3*1+0];
	battary_percent.x = buffer[3*1+1];
	battary_percent.y = buffer[3*1+2];

	pitch.on_off = buffer[3*2+0];
	pitch.x = buffer[3*2+1];
	pitch.y = buffer[3*2+2];

	roll.on_off = buffer[3*3+0];
	roll.x = buffer[3*3+1];
	roll.y = buffer[3*3+2];

	airspeed.on_off = buffer[3*4+0];
	airspeed.x = buffer[3*4+1];
	airspeed.y = buffer[3*4+2];

	GPS_number.on_off = buffer[3*5+0];
	GPS_number.x = buffer[3*5+1];
	GPS_number.y = buffer[3*5+2];

	home_direction.on_off = buffer[3*6+0];
	home_direction.x = buffer[3*6+1];
	home_direction.y = buffer[3*6+2];

	horizonr.on_off = buffer[3*7+0];
	horizonr.x = buffer[3*7+1];
	horizonr.y = buffer[3*7+2];

	home_distance.on_off = buffer[3*8+0];
	home_distance.x = buffer[3*8+1];
	home_distance.y = buffer[3*8+2];

	home_altitude.on_off = buffer[3*9+0];
	home_altitude.x = buffer[3*9+1];
	home_altitude.y = buffer[3*9+2];

	clamb_speed.on_off = buffer[3*10+0];
	clamb_speed.x = buffer[3*10+1];
	clamb_speed.y = buffer[3*10+2];

	flight_mode.on_off = buffer[3*11+0];
	flight_mode.x = buffer[3*11+1];
	flight_mode.y = buffer[3*11+2];

	gps_value.on_off = buffer[3*12+0];
	gps_value.x = buffer[3*12+1];
	gps_value.y = buffer[3*12+2];

	on_time.on_off = buffer[3*13+0];
	on_time.x = buffer[3*13+1];
	on_time.y = buffer[3*13+2];

	heading.on_off = buffer[3*14+0];
	heading.x = buffer[3*14+1];
	heading.y = buffer[3*14+2];

}

void OSD_test_display(void)
{
	//load_item_value(deflaut_item_value);
	if(battary_voltage.on_off) panBatt_A(battary_voltage.x, battary_voltage.y);
	if(battary_percent.on_off) panBatteryPercent(battary_percent.x, battary_percent.y);
	if(pitch.on_off) panPitch(pitch.x, pitch.y);
	if(roll.on_off) panRoll(roll.x, roll.y);	
	if(airspeed.on_off) panAirSpeed(airspeed.x, airspeed.y);
	if(GPS_number.on_off) panGPSats(GPS_number.x, GPS_number.y);
	if(home_direction.on_off) panHomeDir(home_direction.x, home_direction.y);
	if(horizonr.on_off) panHorizon(horizonr.x, horizonr.y);	
	if(home_distance.on_off) panHomeDis(home_distance.x, home_distance.y);		
	if(home_altitude.on_off) panHomeAlt(home_altitude.x, home_altitude.y);
	if(clamb_speed.on_off) panClimb(clamb_speed.x, clamb_speed.y);	
	if(flight_mode.on_off) panFlightMode(flight_mode.x, flight_mode.y);		
	if(gps_value.on_off) panGPS(gps_value.x, gps_value.y);			
	if(on_time.on_off) panTime(on_time.x, on_time.y);	
	if(heading.on_off) panHeading(heading.x, heading.y);	
	
}


void load_flash_setting(void)
{
	uint8_t i,checksum = 0;
	
	iflash.read(0x800fc00,Receive_Buffer,64);
	for(i=0;i<61;i++)
	{
		checksum += Receive_Buffer[i];
	}
	if(checksum != (Receive_Buffer[62]^0x5a))
	{
		load_item_value(deflaut_item_value);
		for(i=0;i<63;i++)
		{
			Receive_Buffer[i] = 0;
		}
		for(i=0;i<63;i++)
		{
			Receive_Buffer[i] =deflaut_item_value[i];
		}
		checksum = 0;
		for(i=0;i<61;i++)
		{
			checksum += Receive_Buffer[i];
		}	
		checksum = checksum^0x5a;
		Receive_Buffer[62] = checksum; 
		FLASH_Unlock();  //??FLASH???????
		FLASH_ClearFlag(FLASH_FLAG_BSY|FLASH_FLAG_EOP|FLASH_FLAG_PGERR|FLASH_FLAG_WRPRTERR);//?????
		FLASH_ErasePage(0x800fc00);     //???????
		iflash.write(0x800fc00,Receive_Buffer,64);
	}
	else
	{
		load_item_value(Receive_Buffer);
	}
}
	


